//+------------------------------------------------------------------+
//|                                                       WOOOLF.mq4 |
//|                                Copyright  2010, Victor Nicolaev |
//|                                                    vinin.ucoz.ru |
//+------------------------------------------------------------------+
#property copyright "Copyright  2010, Victor Nicolaev"
#property link      "vinin.ucoz.ru"

#property indicator_separate_window
#property indicator_buffers 2
#property indicator_color1 Red
#property indicator_color2 Blue
extern int dt=12;
//---- buffers
double ExtMapBuffer1[];
double ExtMapBuffer2[];
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicators
   SetIndexStyle(0,DRAW_LINE);
   SetIndexBuffer(0,ExtMapBuffer1);
   SetIndexStyle(1,DRAW_LINE);
   SetIndexBuffer(1,ExtMapBuffer2);
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start() {
   int    counted_bars=IndicatorCounted();
   int limit=Bars-counted_bars;
   if (limit>1) {
      limit=Bars-2;
      ExtMapBuffer1[Bars-1]=Open[Bars-1];
      ExtMapBuffer1[Bars-1]=Open[Bars-1];
      
      double tmp=Close[Bars-1]-Open[Bars-1];
      double tmp1=Open[Bars-1]-Low[Bars-1];
      double tmp2=High[Bars-1]-Close[Bars-1];
      double tmp3=Close[Bars-1]-Low[Bars-1];
      double tmp4=High[Bars-1]-Open[Bars-1];
      
      if (tmp<0) {ExtMapBuffer1[Bars-1]=ExtMapBuffer1[Bars-1]-tmp;  ExtMapBuffer2[Bars-1]=ExtMapBuffer2[Bars-1]+tmp3-tmp4;} else
      if (tmp>0) {ExtMapBuffer2[Bars-1]=ExtMapBuffer2[Bars-1]+tmp;  ExtMapBuffer1[Bars-1]=ExtMapBuffer1[Bars-1]+tmp2-tmp1;}
   }
   
   for (int i=limit;i>=0;i--) {
      tmp=Close[i]-Open[i];
      tmp1=Open[i]-Low[i];
      tmp2=High[i]-Close[i];
      tmp3=Close[i]-Low[i];
      tmp4=High[i]-Open[i];
      
      ExtMapBuffer1[i]=ExtMapBuffer1[i+1];
      ExtMapBuffer2[i]=ExtMapBuffer2[i+1];

      if (TimeDay(Time[i])!=TimeDay(Time[i+dt])) {
         ExtMapBuffer1[i]=Open[i];
         ExtMapBuffer2[i]=Open[i];
         if (tmp<0) {ExtMapBuffer2[i]=Open[i]+tmp3-tmp4;  ExtMapBuffer1[i]=Open[i]-tmp;}  else
         if (tmp>0) {ExtMapBuffer1[i]=Open[i]+tmp2-tmp1;  ExtMapBuffer2[i]=Open[i]+tmp;}
      } else {
         if (tmp<0) {ExtMapBuffer2[i]=ExtMapBuffer2[i+1]+tmp3-tmp4; ExtMapBuffer1[i]=ExtMapBuffer1[i+1]-tmp; } else
         if (tmp>0) {ExtMapBuffer1[i]=ExtMapBuffer1[i+1]+tmp2-tmp1;  ExtMapBuffer2[i]=ExtMapBuffer2[i+1]+tmp;}
      }
   }
   

   return(0);
  }
//+------------------------------------------------------------------+